function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);
	
	this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'inside_media_and_entertainment', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:126722,v:'normalState'},{id:126712,v:'normalState'},{id:126702,v:'normalState'},{id:126692,v:'normalState'},{id:126682,v:'normalState'},{id:101,v:'normalState'},{id:95,v:'normalState'},{id:84,v:'normalState'},{id:311,v:'normalState'},{id:305,v:'normalState'},{id:418,v:'normalState'},{id:466,v:'normalState'},{id:1710,v:'normalState'},{id:1702,v:'normalState'},{id:1694,v:'normalState'},{id:1685,v:'normalState'},{id:1672,v:'normalState'},{id:1346,v:'normalState'},{id:1339,v:'normalState'},{id:1897,v:'normalState'},{id:1890,v:'normalState'},{id:109512,v:'normalState'},{id:1982,v:'normalState'},{id:3318,v:'normalState'},{id:3329,v:'normalState'},{id:3340,v:'normalState'},{id:3351,v:'normalState'},{id:3368,v:'normalState'},{id:3377,v:'normalState'},{id:3952,v:'normalState'},{id:65645,v:'normalState'},{id:4800,v:'normalState'},{id:4913,v:'normalState'},{id:4905,v:'normalState'},{id:96342,v:'normalState'},{id:96375,v:'normalState'},{id:96640,v:'normalState'},{id:96538,v:'normalState'},{id:4888,v:'normalState'},{id:5888,v:'normalState'},{id:5877,v:'normalState'},{id:116003,v:'normalState'},{id:6214,v:'normalState'},{id:6687,v:'normalState'},{id:7502,v:'normalState'},{id:5746,v:'normalState'},{id:62194,v:'normalState'},{id:8543,v:'normalState'},{id:110070,v:'normalState'},{id:110059,v:'normalState'},{id:110048,v:'normalState'},{id:8842,v:'normalState'},{id:64025,v:'normalState'},{id:9076,v:'normalState'},{id:9069,v:'normalState'},{id:9062,v:'normalState'},{id:9337,v:'normalState'},{id:9443,v:'normalState'},{id:8930,v:'normalState'},{id:11489,v:'normalState'},{id:11503,v:'normalState'},{id:11654,v:'normalState'},{id:66060,v:'normalState'},{id:65852,v:'normalState'},{id:24626,v:'normalState'},{id:12219,v:'normalState'},{id:12226,v:'normalState'},{id:15268,v:'normalState'},{id:15526,v:'normalState'},{id:16015,v:'normalState'},{id:12914,v:'normalState'},{id:17528,v:'normalState'},{id:12301,v:'normalState'},{id:99991,v:'normalState'},{id:99986,v:'normalState'},{id:99798,v:'normalState'},{id:99793,v:'normalState'},{id:98758,v:'normalState'},{id:98923,v:'normalState'},{id:12317,v:'normalState'},{id:24838,v:'normalState'},{id:12333,v:'normalState'},{id:12340,v:'normalState'},{id:18347,v:'normalState'},{id:18337,v:'normalState'},{id:18327,v:'normalState'},{id:18317,v:'normalState'},{id:18307,v:'normalState'},{id:12415,v:'normalState'},{id:100293,v:'normalState'},{id:100299,v:'normalState'},{id:100761,v:'normalState'},{id:100275,v:'normalState'},{id:100861,v:'normalState'},{id:100257,v:'normalState'},{id:12431,v:'normalState'},{id:24936,v:'normalState'},{id:12447,v:'normalState'},{id:12454,v:'normalState'},{id:20751,v:'normalState'},{id:20741,v:'normalState'},{id:20731,v:'normalState'},{id:20721,v:'normalState'},{id:20711,v:'normalState'},{id:12529,v:'normalState'},{id:101123,v:'normalState'},{id:101307,v:'normalState'},{id:101523,v:'normalState'},{id:101110,v:'normalState'},{id:101631,v:'normalState'},{id:101092,v:'normalState'},{id:12545,v:'normalState'},{id:25079,v:'normalState'},{id:12561,v:'normalState'},{id:12568,v:'normalState'},{id:22471,v:'normalState'},{id:22461,v:'normalState'},{id:22451,v:'normalState'},{id:22441,v:'normalState'},{id:22431,v:'normalState'},{id:12643,v:'normalState'},{id:101842,v:'normalState'},{id:101923,v:'normalState'},{id:102574,v:'normalState'},{id:101829,v:'normalState'},{id:102746,v:'normalState'},{id:101811,v:'normalState'},{id:12659,v:'normalState'},{id:25185,v:'normalState'},{id:24166,v:'normalState'},{id:24173,v:'normalState'},{id:24190,v:'normalState'},{id:24200,v:'normalState'},{id:24210,v:'normalState'},{id:24220,v:'normalState'},{id:24230,v:'normalState'},{id:24245,v:'normalState'},{id:103037,v:'normalState'},{id:103446,v:'normalState'},{id:103019,v:'normalState'},{id:103351,v:'normalState'},{id:103001,v:'normalState'},{id:103144,v:'normalState'},{id:24261,v:'normalState'},{id:62012,v:'normalState'},{id:25971,v:'normalState'},{id:25961,v:'normalState'},{id:25949,v:'normalState'},{id:25940,v:'normalState'},{id:25812,v:'normalState'},{id:26686,v:'normalState'},{id:26770,v:'normalState'},{id:26676,v:'normalState'},{id:27918,v:'normalState'},{id:29541,v:'normalState'},{id:29551,v:'normalState'},{id:54113,v:'normalState'},{id:54284,v:'normalState'},{id:29568,v:'normalState'},{id:29588,v:'normalState'},{id:29598,v:'normalState'},{id:54451,v:'normalState'},{id:54659,v:'normalState'},{id:29615,v:'normalState'},{id:29635,v:'normalState'},{id:29645,v:'normalState'},{id:55297,v:'normalState'},{id:55391,v:'normalState'},{id:29666,v:'normalState'},{id:32305,v:'normalState'},{id:32295,v:'normalState'},{id:55792,v:'normalState'},{id:56286,v:'normalState'},{id:29713,v:'normalState'},{id:32474,v:'normalState'},{id:32484,v:'normalState'},{id:56847,v:'normalState'},{id:57165,v:'normalState'},{id:32497,v:'normalState'},{id:32609,v:'normalState'},{id:32628,v:'normalState'},{id:32758,v:'normalState'},{id:32769,v:'normalState'},{id:32780,v:'normalState'},{id:32791,v:'normalState'},{id:32808,v:'normalState'},{id:32817,v:'normalState'},{id:33361,v:'normalState'},{id:33456,v:'normalState'},{id:138920,v:'normalState'},{id:138910,v:'normalState'},{id:129597,v:'normalState'},{id:33836,v:'normalState'},{id:33846,v:'normalState'},{id:33856,v:'normalState'},{id:33795,v:'normalState'},{id:33803,v:'normalState'},{id:33811,v:'normalState'},{id:33747,v:'normalState'},{id:35395,v:'normalState'},{id:35401,v:'normalState'},{id:35407,v:'normalState'},{id:35413,v:'normalState'},{id:35419,v:'normalState'},{id:35317,v:'normalState'},{id:37594,v:'normalState'},{id:38708,v:'normalState'},{id:38998,v:'normalState'},{id:39376,v:'normalState'},{id:37202,v:'normalState'},{id:43244,v:'normalState'},{id:43627,v:'normalState'},{id:43615,v:'normalState'},{id:43605,v:'normalState'},{id:97201,v:'normalState'},{id:97178,v:'normalState'},{id:97868,v:'normalState'},{id:43465,v:'normalState'},{id:144172,v:'normalState'},{id:45740,v:'normalState'},{id:45747,v:'normalState'},{id:45754,v:'normalState'},{id:45761,v:'normalState'},{id:45768,v:'normalState'},{id:45671,v:'normalState'},{id:110884,v:'normalState'},{id:110873,v:'normalState'},{id:110862,v:'normalState'},{id:110851,v:'normalState'},{id:47609,v:'normalState'},{id:47653,v:'normalState'},{id:128110,v:'normalState'},{id:128100,v:'normalState'},{id:128090,v:'normalState'},{id:128080,v:'normalState'},{id:128070,v:'normalState'},{id:128062,v:'normalState'},{id:48179,v:'normalState'},{id:48161,v:'normalState'},{id:48286,v:'normalState'},{id:48450,v:'normalState'},{id:48534,v:'normalState'},{id:48610,v:'normalState'},{id:48676,v:'normalState'},{id:48732,v:'normalState'},{id:48832,v:'normalState'},{id:48898,v:'normalState'},{id:48993,v:'normalState'},{id:49083,v:'normalState'},{id:128428,v:'normalState'},{id:49227,v:'normalState'},{id:49299,v:'normalState'},{id:49336,v:'normalState'},{id:49423,v:'normalState'},{id:49509,v:'normalState'},{id:49594,v:'normalState'},{id:998,v:'normalState'},{id:1024,v:'normalState'},{id:1034,v:'normalState'},{id:123061,v:'normalState'},{id:1105,v:'normalState'}]};
